; version 3.10 - pt - 1/27/11
;  fixed GetStatusv2k4 to look for "selected" graphics when selecting an instrument (for BIAB 2011)
;  also changed many OT_MESSAGE to OT_USER_REQUESTED_INFORMATION so that data is spoken when requested by user
; version 3.08 - pt 1/25/11
;  changed OT_MESSAGE to OT_USER_REQUESTED_INFORMATION in ReadMemo
; version 3.07 - pt 1/24/11
;  fixed ReadMemo to speak short and long messages for output
; version 3.06 - pt 1/23/11
;  Changed to use the following hotkeys to make it easier in desktop mode:
;  GoToSynthButtons Alt+Shift+F8
;  GetStatus Alt+Shift+G
;  KillSpeech Alt+Shift+K
;  sayLocation Alt+Shift+L
; version 3.05 - pt 1/23/11
;  changed hotkey for reading style memo to alt+shift+m
;  re-worked speaking of style memo for BIAB 2011; version 3.04 - pt 1/21/11
;  added SpeakToolTip to speak pop up tool tips
;  added option to JAWS options menu to turn automatic speaking of tool tips on or off
;  added SpeakTooltip hotkey to readme file
; version 3.0.3 - pt 4/12/2009
;  attempt to fix DC's problem with spacebar and IgnoreMuteSpeechDuringPlayback
; Version 3.0.1 - PT 3/20/09
;  added IgnoreMuteSpeechDuringPlayback so that muting of speech during playback works properly
; version 3.0 - PT - 2-28-09
;  Added the MuteSpeechDuringPlaybackFlag in place of the KillSpeech toggle
;  Added SpeakSpecialKeysFlag and MuteSpeechDuringPlaybackFlag to the Jaws options menu )JawsKey+V)
;  Added the MoveOutOfRadioButtons functions to account for the non-standard way in which BIAB treats sets of radio buttons
;  Removed the Shift+Control+key hotkey conflicts with BIAB for the synth dialog and fixed the Tab and Shift+Tab keys so that they can now bring up these combo boxes instead
;  Fixed speaking of multiple chords within a half-bar
;  Improved speaking of bars and chords using Victor's suggestion so that this is now more responsive and accurate
; Version 2.64 - 11/16/08 - PT
;  Modified GiveLocation() so that the guitar window is properly recognized.
;  Also made a change in SwitchWindows to make sure we are in the chord window after shutting down the guitar window
; version 2.63 - PT - 8/16/08
;  added IniReadInteger to AutoStartEvent and IniWriteInteger to HotKeyHelp in order to save the setting for the SpeakSpecialKeysFlag from session to session
; version 2.63 - pt 9/10/2008
;  added KeyboardHelpHook to speak special BIAB hotkeys (but not perform function)
;  modified SpeakSpecialKeys script so that this works properly
; version 2.62 - PT 8/16/2008
;  added a test for beat!=0 in OutputBarBeatChord function so that bars and beats do not speak during playback
; version 2.61 - PT - 8/5/2008
;  added line in the GetStatusV2k4 function to make sure we were in the "Synth WIndow" window when looking for instruments.  Otherwise, the onscreen "Piano" window was being found.
;  Re-formatted and re-wrote  msgHotkeyHelp

; version 2.6 - pt - 7/15/08
;  added LoopingDialog script to easily bring up looping and navigation options
;  added SpeakSpecialKeys so that BIAB special hotkeys provide feedback to user
;  Speaking of special keys can now be toggled on/off by hitting JawsKey+H twice quickly
;  added braille and speech output for Escape and RepeatChords scripts
;  improved speaking of SpellChordsPhonetic by saying "space" between two successive chords
;  added braille flash messages to show chords and bar/beat info as music is playing and as the user arrows through a song
;  fixed RepeatChords so that when there are two chords in one half measure they speak independently and properly
;  fixed SayChord so that aug and sus chords with an alternate bass speaks better
;  made Ear Training Tutor dialogs accessible with Jaws
; added EarTrainingTutor, IntervalgTutor, ChordTutor, SpeakEarTrainingResults, GetItems
;  added info to main help as well as ScreenHelp to describe use of Ear Training dialog
;  fixed capitalization of Music in GiveLocation function
; version 2.5 - PT - 5/5/08
;  Finished the README file with links, headings, and in HTM format for easy navigation with JAWS
;  Added Insert+F1 key pressed twice to bring up README file

; v 2.02 jm
;fixed end key
; added effects accessibility in audio tab of d x i dialog
; v 2.01 jm
; eliminated special cursor keys for combo boxes
; made synth settings dialog accessible
; all scripts for getting the selected/muted status of instruments use the function getStatusV2k4
; eliminated GetSelectedInstrument function
; updated help messages
; version 2.0 - PT - 4/3/08
;  added ReadStyleMemo() to speak style information when in the Style Picker Dialog

; version 1.9a - PT 3/27/08
; fixed another minor change with speaking chord names with double digits (like a13);

; version 1.9 - 3/18/2008 - PT
;  improved the SayChord function
;  fixed some problems with speaking suspended and augmented chords under some conditions 
;  Also fixed speaking of chords such as c69 which used to speak as c 69 rather than c 6 9

;jm v 1.8a fixed escape key behavior when in virtual buffer
;changed script names of home, end, page up, & page down to reflect their names in default script file
;going to the instrument patch combo box works again
;added a 2nd error message & eliminated a saystring in favor of error messages--corrected a misspelling in message file
;escape key says escape when in virtual buffer
;alt shift k accesses key sig combo box

; version 1.8 - 3/16/08 - PT
;  added the SayChord and ProcessChordBreaks functions to speak the chords in a more natural way.
;  Modified the WindowCreatedEvent function to speak chords
;  Modified the RepeatChord script to say chords three different ways
;  Modified the GoToChordWindow function to use data from jsm and jsh files

; version 1.7 - 3/5/08 - PT
; added WindowCreated event to speak popup messages
; added more constants for window classes, etc. to bbw.jsh

; version 1.6 - 3/3/08 - PT
; fixed SaySelectedInstrument script so that it works with BIAB 2008
; added Select(Instrument) functions so that the selection is spoken when selected
; added bbw.jsh file and include to hold constants
; made the MIDISettings dialog work properly using the FocusChangedEvent rather than the Tab and Shift+Tab keys

; version 1.5 - 3/1/08 - pt
; added MIDIChannel function so that tab and shift+tab now speak column headings in the MIDI settings dialog

; version 1.4 - 2/26/o8 - PT
; now using GetWindowSubTypeCode = 19 for FindInstrumentWindow
; Now using msg constants for instrument names
; Now using TypeKey in scripts to toggle instruments
; Added text to jsd file so that Jaws keyboard manager works to describe the script hotkeys

;version 1.3
;eliminated support for v. 12--killed GetStatusV12 function 1.2
; changed some location finders 1.2
; specifically, looked both at class of focus & class of top level window in GiveLocation function 1.2
; changed Get v2k4 function to prevent a lockup 1.2
;toggle speech function 1.3
;modified home key when virtual viewer or nnot pc cursor 1.3

 include "hjconst.jsh"
include "hjglobal.jsh"
include"common.jsm"
include "bbw.jsh"
include "bbw.jsm"
use "JAWS Braille.jsb"

globals
 handle previous,
int switch,
int timebase,
int drumrow,
int drumbeat,
int PrevBar,
int PrevBeat,
int homeflag,
int notfirsttime,
int version,
int XPos,
int YPos,
int SpeakSpecialKeysFlag,
int MuteSpeechDuringPlaybackFlag,
int IgnoreMuteSpeechDuringPlayback,
int SpeakToolTipsFlag,
int DXIComboBoxNumber,
string DXITrack,
string LastNewText



Script test ()

;SwitchToConfiguration ("default")
;SayString("Switching to default configuration")

EndScript

Void Function autostartEvent ()

if (notfirsttime == 0) then
let BBWSettingsDir = GetJAWSSettingsDirectory () + "\\bbw.ini"
let SpeakSpecialKeysFlag = IniReadInteger ("ItemsToSpeak", "SpecialKeys", 1, BBWSettingsDir)
let MuteSpeechDuringPlayBackFlag = IniReadInteger ("ItemsToSpeak", "ChordsDuringPlayback", 1, BBWSettingsDir)
let SpeakToolTipsFlag = IniReadInteger ("ItemsToSpeak", "ToolTips", 1, BBWSettingsDir)
let version = GetProgramVersion (GetAppFilePath())
let prevbeat = 0
let prevbar = 0
let DXIComboBoxNumber = 0
let DXITrack = "Synth"
let notfirsttime = 1
endif
EndFunction


Void Function  ResetGlobals()
let switch = 0
let timebase = 0
let drumrow = 0
let drumbeat = 0
let prevbeat = 0
let prevbar = 0
let homeflag = 0
let notfirsttime = 0
let SpeakSpecialKeysFlag = IniReadInteger ("ItemsToSpeak", "SpecialKeys", 1, BBWSettingsDir)
let MuteSpeechDuringPlayBackFlag = IniReadInteger ("ItemsToSpeak", "ChordsDuringPlayback", 1, BBWSettingsDir)
let SpeakToolTipsFlag = IniReadInteger ("ItemsToSpeak", "ToolTips", 1, BBWSettingsDir)
let DXIComboBoxNumber = 0
let DXITrack = "Synth"

EndFunction

Void Function AutoFinishEvent ()

;ResetGlobals()

EndFunction
Int Function isMainWindow(handle hwnd)
return (getWindowClass(GetTopLevelWindow(hwnd)) == wcMainWindow)
EndFunction
Int Function isChord(handle hwnd)
return (getWindowClass(hwnd) == wcChord)
EndFunction

Int Function isBBWDialog (Handle hwnd)
return StringContains (GetWindowClass (GetRealWindow(hwnd)), "DIALOG")
EndFunction

Void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
int ScreenEcho

let ScreenEcho = GetJCFOption (OPT_SCREEN_ECHO)
if ( GetWindowClass (GetParent (FocusWindow)) == wcMidiSettingsDialog ) then
  pause()
  SetJCFOption (OPT_SCREEN_ECHO, 0 )
  MIDISettings()
Else
  SetJCFOption (OPT_SCREEN_ECHO, ScreenEcho)
EndIf

FocusChangedEvent (FocusWindow, PrevWindow)

EndFunction

Void Function WindowCreatedEvent (handle hWindow, int nLeft, int nTop, int nRight, int nBottom)
var
string wcWindow

; the following was included to speak many popup windows
let wcWindow = GetWindowClass(hWindow)
If (wcWindow==wcPopup1)  ||
  (wcWindow==wcPopup2) then
;SayControl (hWindow)
;delay(2)
Say(GetWindowText(HWindow,0), ot_message)
return
EndIf

WindowCreatedEvent (hWindow, nLeft, nTop, nRight, nBottom)
EndFunction




String Function GetBar (handle hwnd)
Var
  string sBar,
  int cnt

let sBar = GetWindowName(hwnd)
let sBar = StringReverse(sBar)
let cnt = StringContains (sBar, "raB")
let sBar = StringLeft (sBar, cnt+2)
let sBar = StringReverse (sBar)
let sBar = StringSegment (sBar, " ", 2)
Return sBar

EndFunction

String Function GetBeat (handle hwnd)
Var
	string sBeat

;if giPriorBeatFlag == 1 then
;	Return 3
;EndIf
let sBeat = GetWindowName(hwnd)
let sBeat = StringReverse(sBeat)
let sBeat = StringSegment(sBeat, " ", 1)
let sBeat = Stringreverse(sBeat)
return sBeat

EndFunction

String Function GiveLocation ()
var
string location,
string text,
string FocusClass,
string TopLevelClass,
int windowtype,
handle wh

;gives location in program
let FocusClass = GetWindowClass(GetFocus())
let FocusClass = StringLower (Focusclass)
;saystring(focusClass)

let TopLevelClass = StringLower(GetWindowClass(GetTopLevelWindow(GetFocus())))
;saystring(toplevelclass)

let windowtype = GetWindowSubtypeCode (GetFocus ())
let text = stringLower(GetWindowTextEx(GetTopLevelWindow(GetFocus()), 0, 1))
;saystring(text)
if (GetWindowSubtypeCode(GetFocus()) == WT_COMBOBOX && FocusClass != "ComboBox") then
return "combo box"
endif

if (menusactive()) then
return "menu"
endif

if (dialogActive() || stringContains(TopLevelClass, "options") || StringContains(TopLevelClass,"dialog") || stringcontains(TopLevelclass,"dlg") || (StringContains(TopLevelclass, "form"))) then
let location =  "dialog"
return location
endif

if (StringContains(GetWindowName(GetRealWindow(GetFocus())),"StyleMaker")) then
let location = "stylemaker"
;return location
endif

if (GetWindowClass(GetFocus()) == wcMainWindow ) then ;we're in the main screen
if (stringContains(text, "rest")) then
;begins to look for various clues to where we are
let location =  "notation"
elif  (stringContains(text, "big lyrics")) then
let location =  "big lyrics"
elif (StringContains(text, "guitar") && stringContains(text, "position") && stringContains(text, "key")) then
let location = "guitar window"
elif (StringContains(text, "lead sheet")) then
let location = "lead sheet window"
elif (StringContains(text, "chord builder") || (stringContains(text, "root") && stringContains(Text, "extension"))) then
let location = "chord builder window"

else
let location =  "chord window"
endif ;begins to look for various clues to where we are
endif ;we're in main screen

if (stringContains(text, "options")) then
let location = "dialog"
elif (stringContains(text, " StyleMaker") || stringContains(text, "end drums") && !stringContains(text, "Drum Pattern Editor")) then ;stylemaker
let location = "stylemaker"
elif (stringContains(text, "Drum Pattern Editor")) then
let location = "drum pattern editor"
; pt 11/08 - replaced the following line with the one after so that the guitar window is properly recognized
;elif (StringContains (GetWindowName (GetAppMainWindow (GetFocus ())), "Guitar")) then
elif GetWindowClass (GetFocus()) == "TGuitarView" then
let location = "guitar window"
elif (stringContains(text,"guess")) then
let location = "ear training"
endif
RestoreCursor()
return location

EndFunction

Void Function setfocusToStylemaker ()

JawsCursor()
RouteJawsToPc()
JawsPageDown()
SetFocus(GetCurrentWindow())
PcCursor()
EndFunction

Int Function GetStyleRow (string text)
var
int leftRowPos,
int rightRowPos,
string srow,
int row,
int numchars

let leftRowPos = stringContains(text, "Row")
if (leftRowPos) then ; the word row was found
let leftrowPos = leftRowPos+4
let rightRowPos = stringContains(text, ",")
let numchars = rightRowPos-leftRowPos
let srow = substring(text, leftRowPos, numchars)
let row = stringToInt(srow)
endif
if (row == 0) then
let row = 1
endif
return row
EndFunction


Int Function GetStyleColumn (string text)

var
string scolumn,
int column,
int leftColPos,
int rightColPos,
int numchars

let leftColPos = stringContains(text, "Column")+6
let rightColPos = stringContains(text, "patterns.")
let numchars = rightColPos-LeftColPos
let text =  substring(text, leftColPos, numchars)
let leftColPos = 1
let rightColPos = stringContains(text, "]")
let numchars = rightColPos-leftColPos 
let scolumn = substring(text, leftColPos, numChars)
let column = StringToInt (scolumn)
return column

EndFunction

String Function goToChordWindow ()

var
string ChordBuffer,
handle wh

;{ctrl+w}
pause()
let wh = FindWindow(GetTopLevelWindow(GetCurrentWindow()),wcChord,"")
if (wh) then
let ChordBuffer = GetWindowText(wh, 1)
else
SayMessage(OT_MESSAGE, msgErr2 )  ; can't find chord window
endif
;{ctrl+w}
pause()
return chordbuffer
EndFunction


Void Function drumedit ()

var
string text

let text = StringLower(GetWindowText(TopLevelWindow(GetCurrentWindow()),0))

EndFunction

Void Function what2do (string where)
var
  handle hwnd,
  int bar,
  int beat,
  string chordbuffer
;speechOn()

if (where == "virtual viewer") then
return "virtual viewer"
endif
if (where == "stylemaker") then
stylemaker()
return
elif (where == "drum pattern editor") then
drumEdit()
return
elif (where == "chord window" || where == "notation" || where == "guitar window") then
;delay(3)
if GoToChordWindow() == "" then
  ; PT only speak the bar/beat if there is no chord, otherwise the SayHighlightedText function does this
  PerformScript sayBar()
; PT - also, if there is no chord, we need to reset prevbar and prevbeat
  let hwnd = GetTopLevelWindow(GetCurrentWindow())
  let prevbar = StringToInt(GetBar(hwnd))
  let prevbeat = StringToInt(GetBeat(hwnd))
EndIf
endif;location
return

EndFunction

Script PrevInstrument ()
var
string where
let where = giveLocation()
typeKey("shift+f6")
delay(2)
if (where == "stylemaker") then
PerformScript SaySelectedInstrument()
endif
EndScript

Script NextInstrument ()
var
string where,
string wintext,
handle wh

let where = giveLocation()
typeKey("f6")
delay(2)
if (where == "stylemaker") then
PerformScript SaySelectedInstrument()
elif (where == "drum pattern editor") then
let wh = findDescendantWindow(GetTopLevelWindow(GetCurrentWindow()),1900)
let wintext = GetWindowText(wh, 0)
say(wintext, ot_string)
endif
EndScript

void function SayHighlightedText( handle Window, string Text )
var
  int BrailleOnly

if isChord(window) then
  if IgnoreMuteSpeechDuringPlayback then
    let BrailleOnly = 0
  else
    let BrailleOnly = MuteSpeechDuringPlaybackFlag
  EndIf
  OutputBarBeatChord(text,BrailleOnly)
  return
EndIf

SayHighlightedText ( Window, Text )

EndFunction


Script sayBar ()
var
string sBar,
string sBeat,
handle hwnd

let hwnd = getTopLevelWindow(GetCurrentWindow())
let sBar = getBar(hwnd)
let sBeat = getbeat(hwnd)
if(StringToInt(sBar)) then
SayString(sBar)
else
say("bar number not found", ot_message)
endif
if (StringToInt(sBeat)) then
SayString(sBeat) 
else
say("beat not found",OT_message)
endif
if BrailleInUse () && !BrailleIsMessageBeingShown () then
  BrailleMessage( sBar+":"+sBeat+" ", 0, 0 )
EndIf

EndScript

Void Function ComboBox (handle wh, string scriptkeyname)

SpeechOff()
pause()
TypeKey(scriptkeyname)
pause()
if (ScriptKeyName == "esc") then
SpeechOn()
TypeKey(scriptKeyname)
;saystring("script key name is "+scriptkeyname)
;say("escape", ot_message)
;LeftMouseButton()
;return
endif
if (StringContains(GetWindowName(GetRealWindow(GetFocus())), "DirectX Plugins")) then
delay(2)
endif
if (MoveToWindow(wh)) then ;can move to combo box
pause()
SetFocus(wh)
PcCursor()
else
if (ScriptKeyName != "esc") then
saystring("cannot move to window")
endif
SetFocus(wh)
PcCursor()
endif
SpeechOn()
if (GetWindowClass(wh) == "ComboLBox") then
SayFocusedObject ()
endif
return
EndFunction

Script GoToPatchBox ()
var
handle wh

let wh = FindWindow (GetAppMainWindow (GetCurrentWindow ()), "TSynthWindow", "")
if (wh) then
let wh = GetFirstChild(wh)

if (wh) then
let wh = GetLastWindow(wh)
let wh = GetFirstChild(wh)
let wh = GetLastWindow(wh)
setFocus(wh)
endif
endif
EndScript


Void Function styleMaker ()

var
string text,
string selectedInstrument,
int column,
int row

let text = GetWindowname(GetRealWindow(GetCurrentWindow()))
let row = getStyleRow(text)
let column = getStyleColumn(text)
let selectedInstrument = GetStatusV2k4("all", "s")
if (selectedInstrument == "drums") then
if (row == 1) then
SayUsingVoice(VCTX_pcCursor, "eigh", ot_string)
elif (row == 2) then
SayUsingVoice (vctx_pccursor, "b", ot_string)
elif (row == 3) then
SayUsingVoice (vctx_pccursor, "fills", ot_string)
elif (row == 4) then
SayUsingVoice (vctx_pccursor, "end drums", ot_string)
endif
endif

if (selectedInstrument != "drums") then
if (row == 1) then
saystring ("eigh 8 beat")
elif (row == 2) then
saystring("eigh 4 beat")
elif (row == 3) then
saystring("eigh 2 beat")
elif (row == 4) then 
saystring("eigh 1 beat")
elif (row == 5) then
saystring("b 8 beat")
elif (row == 6) then 
saystring("b 4 beat")
elif (row == 7) then 
saystring("b 2 beat")
elif (row == 8) then 
saystring("b 1 beat")
elif (row == 9) then
saystring("ending")
endif ;not drums
endif ;row = 1
sayInteger(column)
let text = ""
PcCursor()
return
EndFunction

Script SayNextCharacter()
Var
  handle hwnd
if isMainWindow(GetCurrentWindow()) then
	TypeCurrentScriptKey()
  let IgnoreMuteSpeechDuringPlayback = 1
  OutputBarBeatChord(" ",0)
	Return
EndIf

PerformScript SayNextCharacter()

EndScript

Script sayPriorCharacter()
Var
  handle hwnd,
  string text,
  string ChordBuffer

	if isMainWindow(GetCurrentWindow()) then
	TypeCurrentScriptKey()
  let IgnoreMuteSpeechDuringPlayback = 1
  if (PrevBar==1) && (PrevBeat==1) then
  ; if we are at bar 1, beat 1, then SayHighlightedText will not catch any change
  ; so, we must process that exception here
  PerformScript SayBar()
    let ChordBuffer = GoToChordWindow()
    let text = StringSegment (ChordBuffer, " ", 1)
    BrailleClearMessage (FALSE)
    OutputBarBeatChord(text,0)
    let text = StringSegment (ChordBuffer, " ", 2)
    ; if there is a second chord in this part of the measure, speak it also
    if text != "" then   OutputBarBeatChord(text,0) EndIf
      Return
  EndIf
  OutputBarBeatChord(" ",0)
	Return
EndIf
PerformScript SayPriorCharacter()

EndScript

Script SayPriorLine ()

var
string where,
string ScriptKeyName,
handle wh

if (!isPcCursor()) then
PerformScript SayPriorLine()
return
endif

let where = givelocation()

if (where == "combo box") then
let wh = GetFocus()
let scriptkeyname = GetCurrentScriptKeyName ()
ComboBox(wh, scriptkeyname)
return
endif ;combo box

			if (MenusActive () || DialogActive () || !isPcCursor() || IsVirtualPcCursor() || CaretVisible()) then
PerformScript SayPriorLine()
return
endif

if (where == "dialog") then
PerformScript SayPriorLine()
return
endif

PriorLine()
what2do(where)

EndScript

Script sayNextLine ()
var
string where,
string ScriptKeyName,
handle wh

let where = givelocation()
let scriptkeyname = GetCurrentScriptKeyName ()
if (!isPcCursor()) then
PerformScript SayNextLine()
return
endif

if (GetWindowSubTypeCode(GetFocus()) == wt_combobox) then
let wh = GetFocus()
combobox(wh, scriptkeyname)
return
endif

if ((MenusActive ()) || (DialogActive ()) || (!isPcCursor()) || IsVirtualPcCursor() || CaretVisible()) then
PerformScript SayNextLine()
return
endif

if (where == "dialog") then
PerformScript SayNextLine()
return
endif

NextLine()
what2do(where)
EndScript

String Function GetStatusV2k4 (string instrument, string checkfor)

;this function checks both the selected &/or muted/unmuted states of either specific instruments or all as a whole
;if checking a specific instrument, e.g., its toggle or selection key is pressed,
; then the window name of the instrument is sought, eliminating findStrings
; the 1st parameter, instrument, will contain that instrument's name
;if the status of all instruments is being checked, then the function goes thru all instruments
; the instrument name in this case is "all"
;checkfor differentiates whether we're checking an instrument's toggle or selected state
; t is for toggle, e.g., is it muted or unmuted
;s is whether it's selected

var
handle wh,
string muted,
string selected,
int done

let wh = GetTopLevelWindow(GetCurrentWindow())
;used top level so this function will work in main window & style maker
if (wh) then ;top level window found
if (instrument != "all") then ;looking for specific instrument
; wctlmd constant for class TLMDRadioButton in bbw.jsh
;looking for a single instrument w/specified name
; PT - added the next line to make sure we were only looking in the "Synth WIndow" window
let wh = FindWindow (wh, "", "Synth WIndow")
let wh = FindWindow (wh, "", instrument) ;look for the radio button w/instrument name
if (wh) then ;the window name of the specific instrument was found
MoveToWindow(wh)
NextCharacter()
if (checkfor == "t") then ;muted or not
if (stringContains(GetColorName (GetColorText ()),"red")) then ;red
let muted = muted+getWindowName(wh)+space+msgMuted
PcCursor()
say(muted , ot_USER_REQUESTED_INFORMATION)
return
else
PcCursor()
say (instrument + " unmuted", ot_USER_REQUESTED_INFORMATION)
return
endif ;red

elif (checkfor == "s") then ;selected
; pt 1-27-11 - added check for "selected" graphics for BIAB 2011
if (FindGraphic(GetCurrentWindow(), "bullet", s_top, s_restricted)) ||
(FindGraphic(GetCurrentWindow(), "selected", s_top, s_restricted)) then
let selected = instrument + space +msgSelected
endif ;bullet
PcCursor()
endif ;checkfor = t
PcCursor()
say(selected, ot_USER_REQUESTED_INFORMATION)
endif ; specific instrument found
else ;not looking for specific instrument, testing all instrument's status
;find 1st radio button

let wh = findWindowByType (wh, wt_radioButton)
if (wh) then ;a radio button was found
while (wh && !done)
if (GetWindowSubTypeCode(wh) == wt_radioButton) then
let done = 0
else
let done = 1
endif

if (!done) then ; not done yet
MoveToWindow(wh)
;Saystring(GetWindowName(wh))
NextCharacter()

if (checkfor == "t") then ;toggle
if (stringContains(GetColorName (GetColorText ()),"red")) then ;red
let muted = muted+getWindowText(wh, 0)+space +"&"
endif ;red

elif (checkfor == "s") then
if (FindGraphic(GetCurrentWindow(), "bullet", s_top, s_restricted)) then
PcCursor()
let instrument = GetWindowName(wh)
if (stringContains(instrument, " (")) then
; kill pattern numbers & just return selected instrument
let instrument = StringSegment(instrument, " ",1)
let selected = instrument + space +msgSelected
return selected
endif; string contains pattern numbers, kill that
let selected = instrument + space +msgSelected

let done = 1
PcCursor()
say(selected, ot_USER_REQUESTED_INFORMATION)  ;since only 1 can be selected at a time, we're done
endif ;bullet

endif ;checkfor
let wh = GetNextWindow(wh)
endif ;done or not
endWhile
endif ;radio button found
endif ;looking for specific instrument
endif ;main window

PcCursor()

if (checkfor == "t") then
if (muted == "") then
let muted = "no instruments "+msgMuted
else
let muted = stringChopRight(muted, 1) ;kill the last &
let muted = muted+space+msgMuted
endif
say (muted, ot_USER_REQUESTED_INFORMATION)
endif
EndFunction

Script ToggleCombo ()

TypeKey (ks2)
delay(2)
GetStatusV2k4(MsgCombo, "t")
EndScript

Script ToggleBass ()

TypeKey (ks3)
delay(2)
GetStatusv2k4(MsgBass, "t")

EndScript

Script TogglePiano ()

TypeKey(ks4)
delay(2)
GetStatusV2k4(MsgPiano, "t")

EndScript

Script ToggleDrums ()

TypeKey(ks5)
delay(2)
GetStatusV2k4(MsgDrums, "t")

EndScript

Script ToggleGuitar ()

typeKey(ks6)
delay(2)
GetStatusV2k4(MsgGuitar, "t")

EndScript

Script ToggleSoloist ()

TypeKey(ks7)
delay(2)
GetStatusV2k4(MsgSoloist, "t")

EndScript

Script ToggleStrings ()

TypeKey(ks8)
delay(2)
GetStatusV2k4(msgStrings, "t")

EndScript

Script ToggleMelody ()

TypeKey(ks9)
delay(2)
GetStatusV2k4(msgMelody, "t")

EndScript

Script ToggleThru ()

TypeKey(ks0)
delay(2)
GetStatusV2k4(MsgThru, "t")

EndScript

Script SelectCombo ()

TypeKey(ks12)
delay(2)
GetStatusV2k4("combo", "s") 

EndScript

Script SelectBass ()

TypeKey(ks13)
GetStatusV2k4("bass", "s")

EndScript

Script SelectPiano ()

TypeKey( ks14 )
delay(2)
GetStatusV2k4("piano", "s")

EndScript

Script SelectDrums ()

TypeKey(ks15)
pause()
GetStatusV2k4("Drums", "s")

EndScript

Script SelectGuitar ()

TypeKey(ks16)
pause()
GetStatusV2k4("Guitar", "s")

EndScript

Script SelectSoloist ()

TypeKey(ks17)
pause()
GetStatusV2k4("Soloist", "s")

EndScript

Script SelectStrings ()

TypeKey(ks18)
pause()
GetStatusV2k4("Strings", "s")

EndScript

Script SelectMelody ()

TypeKey(ks19)
pause()
GetStatusV2k4("Melody", "s")

EndScript

Script SelectThru ()

TypeKey(ks00)
pause()
GetStatusV2k4("Thru", "s")

EndScript

Script GetStatus ()

getStatusV2k4("all", "t")

EndScript

Script SaySelectedInstrument ()
var
string text

let text =GetStatusV2k4("all", "s")
say(text, ot_message)

/*if (StringContains(GetWindowText(GetRealWindow(GetCurrentWindow()),0), "StyleMaker")) then
sayString(GetSelectedInstrument())
else
saystring("not in stylemaker, no instrument selected.")
endif*/

EndScript

Script HotKeyHelp ()

delay(2)
if IsKeyWaiting () then return EndIf
if IsSameScript () == 1 then
  ; toggle SpeakSpecialKeysFlag
  if SpeakSpecialKeysFlag == 0 then
    let SpeakSpecialKeysFlag = 1
    SayMessage(OT_MESSAGE,msgSpeakSpecialKeysON)
  else
    let SpeakSpecialKeysFlag = 0
    SayMessage(OT_MESSAGE,msgSpeakSpecialKeysOff)
  EndIf
  ; save setting in bbw.jsi
  IniWriteInteger ("ItemsToSpeak", "SpecialKeys", SpeakSpecialKeysFlag, BBWSettingsDir )
  return
EndIf

If UserBufferIsActive () Then
	UserBufferDeactivate ()
EndIf

SayFormattedMessage (OT_USER_BUFFER, msgHotKeyHelpGeneral)

EndScript

Script JAWSHome()
Var
	handle hwnd

if (isPCCursor() && !MenusActive()) then
  TypeCurrentScriptKey()
  if isMainWindow(GetCurrentWindow()) then
      OutputBarBeatChord(" ",0)
  EndIf
else
  PerformScript JAWSHome ()
EndIf
EndScript

Script JAWSEnd()
Var
	handle hwnd

if (isPCCursor() && !MenusActive()) then
  TypeCurrentScriptKey()
  if isMainWindow(GetCurrentWindow()) then
      OutputBarBeatChord(" ",0)
  EndIf
else
  PerformScript JAWSEnd()
EndIf
EndScript

Script JawsPageDown ()
var
string where,
string ScriptKeyName

if (!isPcCursor() || isVirtualPcCursor() || caretVisible()) then
PerformScript JAWSPageDown()
return
endif

let where = GiveLocation()

if (where == "combo box") then
let ScriptKeyName = GetCurrentScriptKeyName ()
ComboBox(GetFocus(), scriptkeyname)
return
endif

PerformScript JAWSPageDown()
pause()
if (where == "chord window" || where == "notation" && isPcCursor()) then
what2do(where)
else
sayword()
endif

EndScript

Script JawsPageUp ()
var
string where,
string ScriptKeyName
if (!isPcCursor() || isVirtualPcCursor() || caretVisible()) then
PerformScript JAWSPageUp()
return
endif

let where = GiveLocation()
if (where == "combo box") then
let ScriptKeyName = GetCurrentScriptKeyName ()
ComboBox(GetFocus(), scriptkeyname)
return
endif

PerformScript JawsPageUp()
pause()
if (where == "chord window" || where == "notation" && isPcCursor()) then
what2do(where)
else
sayword()
endif

EndScript


Void Function sayCharacterPhonetically (string char)
var
string getPhoneticWord,
string keyval
let keyval = char
let GetPhoneticWord = IniReadString ("PhoneticSpell", char, "", "default.jcf")
saystring(getphoneticword)
if (getphoneticword == "") then
saystring(char)
endif
EndFunction

Void Function SpellChordsPhonetic (string chordbuffer)

var
int i,
string char
let i = 1
while (i <= stringlength(chordbuffer))
let char = stringLower(SubString (chordbuffer, i, 1))
sayCharacterPhonetically(char)
if char == " " then SayString("space") EndIf
let i = i+1
endWhile

EndFunction

Script repeatChords ()
var
string ChordBuffer,
string text,
int n

let chordBuffer = GoToChordWindow()
let n = IsSameScript()
speechOn()

  if ChordBuffer == "" then
    SayMessage( OT_USER_REQUESTED_INFORMATION, msgNoChord)
  EndIf

if n == 0 then
  let text = StringSegment (ChordBuffer, " ", 1)
  OutputBarBeatChord(text,0)
  let text = StringSegment (ChordBuffer, " ", 2)
  ; if there is a second chord in this part of the measure, speak it also
  if text != "" then   OutputBarBeatChord(text,0) EndIf
ElIf n == 1 then
  SpellString(ChordBuffer)
  OutputBarBeatChord(ChordBuffer,1)
ElIf n == 2 then
  SpellChordsPhonetic(ChordBuffer)
  OutputBarBeatChord(ChordBuffer,1)
endif

EndScript

Script enterkey ()
var
string where
if (menusactive() || dialogactive() || stringContains(GetWindowClass(GetTopLevelWindow(GetCurrentWindow())),"Form")) then
TypeKey("enter")
say("enter",ot_message)
return
endif
let where = giveLocation()
TypeKey("enter")
pause()
say("enter",ot_message)
what2do(where)
EndScript

Void Function ImportMidi ()

var
handle wh, ;window handle
handle wh1,
int ci ;control id

let ci = GetCurrentControlID()
if (ci == 211 || ci == 212 || ci == 213 || ci == 214 || ci == 215 || ci == 216 || ci == 217 || ci == 218 || ci == 219 || ci == 220 || ci == 221 || ci == 222 || ci == 223 || ci == 224 || ci == 225 || ci == 226) then
let wh1 = getFocus()
let wh = getPriorWindow(GetFocus())
SayWindowTypeAndText (wh)
endif
EndFunction

Void Function AssignPatches ()
var
int cid

let cid = GetCurrentControlID()
if (cid == 200) then
say("bass",ot_message)
elif (cid == 201) then
say("piano",ot_message)

elif (cid == 202) then
say("drums",ot_message)
elif (cid == 203) then
say("guitar",ot_message)
elif (cid == 204) then
say("soloist",ot_message)
elif (cid == 205) then
say("strings",ot_message)
elif (cid == 206) then
say("melody",ot_message)
elif (cid == 207) then
say("thru",ot_message)

endif
EndFunction

Void Function preferences ()

var
int cid
let cid = GetCurrentControlID()
if (cid == 65535) then
speechOff()
delay(15)
speechOn()
sayline()
return
endif

EndFunction

Void Function track2track ()
if (FindGraphic (GetCurrentWindow (), "MAXIMIZE SYMBOL", s_top, s_unrestricted)) then
LeftMouseButton()
endif
if (GetWindowClass(Getfocus()) == "TCheckBox" && !stringContains(GetWindowText(GetFocus(),0),"merge")) then
InvisibleCursor()
RouteInvisibleToPc()
NextLine()
PriorCharacter()
SayWord()
PcCursor()
endif
EndFunction

void function MIDISettings()
var
int i,
int done,
int cid,
int cid0,
string instrument,
string text
	
let i = 0
let done = 0
let cid0 = GetControlID (GetFocus ()  )
;SayString(IntToString(cid0))
SaveCursor ()
RouteJAWSToPc ()
JawsCursor()
JawsHome()
if !( GetWindowClass (GetCurrentWindow()) == wcMidiSettingsDialog ) then
return
EndIf

while (i<=8) && (done==0) 
let i = i + 1
NextChunk ()
let cid = GetControlID ( GetCurrentWindow () )
;SayString(inttostring(cid))
If cid == cid0 Then
let done = 1
EndIf
EndWhile

let text = StringSegment (msgMCHeadings, delimiter,i)
SayFormattedMessage( OT_JAWS_MESSAGE, text )

EndFunction


void function MonitorNewTextEventAlerts(handle hFocus, handle hwnd, string buffer, int nAttributes,
	int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)

;SayInteger(nBackgroundColor)
;SayInteger(nTextColor)
if nBackGroundColor == 14811135 then
  ;SayString(buffer)
let LastNewText = LastNewText + buffer + "\n"
EndIf

MonitorNewTextEventAlerts(hFocus, hwnd, buffer, nAttributes,
	nTextColor, nBackgroundColor, nEcho, sFrameName)

EndFunction


Script TabKey()
var
  string DXITrackHold


if StringContains( GetWindowName (GetRealWindow(GetFocus())), "VST/DirectX" ) then
  ; if in the synth settings dialog
  let DXITrackHold = DXITrack
  let DXIComboBoxNumber = DXIComboBoxNumber + 1
  if DXITrack == "Synth" then
    if DXIComboBoxNumber > 4 then
      let DXIComboBoxNumber = 1
      let DXITrack = "Audio"
    EndIf
  ElIf DXITrack == "Audio" then
    if DXIComboBoxNumber > 3 then
      let DXIComboBoxNumber = 1
      let DXITrack = "Synth"
    EndIf
  Else
    let DXITrack = "Synth"
    let DXIComboBoxNumber = 1
  EndIf

  ; if a switch was made between synth and audio settings, we need to do the following:
  if StringCompare (DXITrack, DXITRACKHold, FALSE) then
    FindString (GetTopLevelWindow (GetFocus()), DXITrack+" Track", S_TOP, s_UNRESTRICTED)
    LeftMouseButton ()
    SayString(msgSwitchingTo + DXITrack + msgTrack )
  EndIf

  FindComboBox	( DXIComboBoxNumber, DXITrack )

  ; speak a label for the ComboBox that we are on
  if DXITrack == "Synth" then
    SayString( StringSegment (msgSynthCombos, "|", DXIComboBoxNumber) )
  ElIf DXITrack == "Audio" then
    SayString( StringSegment (msgAudioCombos, "|", DXIComboBoxNumber) )
  Else
    SayString("Track type should be either Audio or Synth")
  EndIf
  return
EndIf

; deal with the unusual way that BIAB reacts to sets of radio buttons
if IsPCCursor () && GetWindowTypeCode (GetCurrentWindow(), TRUE)==WT_RADIOBUTTON then
  MoveOutOfRadioButtons(1)
  return
EndIf

TabKey()
let LastNewText = ""
Pause()
RouteJAWSToPc ()
;say("tab", ot_help)

if SpeakToolTipsFlag == 1 then
	Delay(10)
	PerformScript speakToolTip()
EndIf

delay(2)
if (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Import MIDI File")) then
ImportMidi()
endif
if (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Assign Instruments")) then
assignPatches()
endif
if (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Preferences")) then
preferences()
endif
if (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Track-to-Track")) then
track2track()
endif
EndScript


Script shifttabkey ()
var
  string DXITrackHold,
	handle hwnd

if StringContains( GetWindowName (GetRealWindow(GetFocus())), "VST/DirectX" ) then
  ; if in the synth settings dialog
  let DXITrackHold = DXITrack
  let DXIComboBoxNumber = DXIComboBoxNumber - 1
  if DXITrack == "Synth" then
    if DXIComboBoxNumber < 1 then
      let DXIComboBoxNumber = 3
      let DXITrack = "Audio"
    EndIf
  ElIf DXITrack == "Audio" then
    if DXIComboBoxNumber < 1 then
      let DXIComboBoxNumber = 4
      let DXITrack = "Synth"
    EndIf
  Else
    let DXITrack = "Synth"
    let DXIComboBoxNumber = 1
  EndIf

  ; if a switch was made between synth and audio settings, we need to do the following:
  if StringCompare (DXITrack, DXITRACKHold, FALSE) then
    FindString (GetTopLevelWindow (GetFocus()), DXITrack+" Track", S_TOP, s_UNRESTRICTED)
    LeftMouseButton ()
    SayString(msgSwitchingTo + DXITrack + msgTrack )
  EndIf

  FindComboBox	( DXIComboBoxNumber, DXITrack )

  ; speak a label for the ComboBox that we are on
  if DXITrack == "Synth" then
    SayString( StringSegment (msgSynthCombos, "|", DXIComboBoxNumber) )
  ElIf DXITrack == "Audio" then
    SayString( StringSegment (msgAudioCombos, "|", DXIComboBoxNumber) )
  Else
    SayString("Track type should be either Audio or Synth")
  EndIf
  return
EndIf

; deal with the unusual way that BIAB reacts to sets of radio buttons
if IsPCCursor () && GetWindowTypeCode (GetCurrentWindow(), TRUE)==WT_RADIOBUTTON then
  MoveOutOfRadioButtons(-1)
  return
EndIf

ShiftTabKey ()
let LastNewText = ""
Pause()
RouteJAWSToPc ()
;say("shift tab", ot_help)
delay(2)
if (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Import MIDI File")) then
ImportMidi()
elif (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Assign Instruments")) then
assignPatches()
elif (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Preferences")) then
preferences()
elif (StringContains(GetWindowName(GetRealWindow(GetFocus())), "Track-to-Track")) then
track2track()
endif

EndScript

Script SayNextWord ()
var
string where

typeKey("tab")
if (menusActive() || dialogactive() || !IsPcCursor() || IsVirtualPCCursor () || CaretVisible()) then
PerformScript SayNextWord()
return
endif
if (!menusactive() && !dialogActive() && isPcCursor()) then
let where = givelocation()
if (where == "notation window" || where == "chord window" && isPcCursor() && !menusactive() && !dialogActive()) then
TypeKey("control+right arrow")
return
endif
else
PerformScript SayNextWord()
endif
EndScript

Script SayPriorWord ()

var
string where
if (menusActive() || dialogactive() || !IsPcCursor() || IsVirtualPCCursor () || CaretVisible()) then
PerformScript SayPriorWord()
return
endif

let where = givelocation()
if (where == "notation window" || where == "chord window") then
typeKey("control+left arrow")
return
else
PerformScript SayPriorWord()
endif

EndScript



Script OpenMidFile ()

if (findString(GetCurrentWindow(), "(Change)", s_top, s_unrestricted)) then
LeftMouseButton()
else
saystring("no button found")
endif
PcCursor()
EndScript





Script scriptFileName ()

var 
string msg

;let msg = msgScriptInfo + GetAppFileName ()
let msg = FormatString (msgScriptInfo, ReleaseNumber, ReleaseDate, GetAppFileName() )
say(msg, ot_message)
spellstring(GetAppFilename())

EndScript

Script ScreenHelp ()
var
  string where,
  string dir

If UserBufferIsActive () Then
	UserBufferDeactivate ()
EndIf

if IsSameScript () then
  let dir = GetJAWSSettingsDirectory ()
  ;SayFormattedMessage(OT_USER_BUFFER, dir+"\\" )
  If FileExists (dir+"\\"+bbwReadMeFile) then
    run ("hh "+dir+"\\"+bbwReadMeFile)
  Else
    SayMessage( OT_MESSAGE, msgErr5 )
  EndIf
  return
EndIf

let where = GiveLocation()
if where == "ear training" then
SayFormattedMessage( OT_USER_BUFFER, msgScreenHelp4 )
return
endif

if (!menusActive() && !dialogActive() && GetWindowClass(GetFocus()) == "tBandWindow") then
let where = givelocation()
if (where == "stylemaker" || where == "drum pattern editor") then
SayFormattedMessage (OT_USER_BUFFER, msgScreenHelp1)
endif

if (where == "chord window") then
SayFormattedMessage( OT_USER_BUFFER, msgScreenHelp2 )
elif (where == "notation") then
SayFormattedMessage( OT_USER_BUFFER, msgScreenHelp3 )
elif where == "ear training" then
SayFormattedMessage( OT_USER_BUFFER, msgScreenHelp4 )
endif
else
PerformScript ScreenSensitiveHelp()
endif

EndScript

Script sayLocation ()

saystring(givelocation())

EndScript


Script RecDrumPattern ()

TypeKey("f3")
delay(5)
let drumrow = 1
let drumbeat = 1
EndScript

Script esckey ()
var
string where,
string ChordBuffer,
string text,
int bar,
int beat,
handle hwnd

if (UserBufferIsActive ()) then
say("esc", ot_message)
UserBufferDeactivate ()
return
endif

if (StringContains(GetWindowName(GetTopLevelWindow(GetCurrentWindow())),"DirectX Plugins")) then
say("escape", ot_message)
typeKey("alt+f4")
return
endif
let where = givelocation()

if (where == "menu" || where == "dialog") then ;menu or dialog
say("escape", ot_message)
typeKey("esc")
return
endif; menu or dialog

if (where == "synth window") then ;synth window
typeKey("esc")
say("escape",ot_message)
return
endif ;synth window

if where == "notation" then ;notation
let IgnoreMuteSpeechDuringPlayback = 1
typeKey("esc")
performScript sayBar()
EndIf ; notation
if (where == "chord window") then ;chord window only
let IgnoreMuteSpeechDuringPlayback = 1
  typeKey("esc")
  let hwnd = GetTopLevelWindow(GetCurrentWindow())
  let bar = StringToInt(GetBar(hwnd))
  let beat = StringToInt(GetBeat(hwnd))
  if (bar==PrevBar) &&  (beat==PrevBeat) then
  ; if the bar or beat do not change, then the SayHighlightedText function will not catch this
  ;  so, we process the output here
  PerformScript SayBar()
  let ChordBuffer = GoToChordWindow()
  let text = StringSegment (ChordBuffer, " ", 1)
  BrailleClearMessage (FALSE)
  OutputBarBeatChord(text,0)
  let text = StringSegment (ChordBuffer, " ", 2)
  ; if there is a second chord in this part of the measure, speak it also
  if text != "" then   OutputBarBeatChord(text,0) EndIf
  EndIf
  return
endif ;chord window only
;other contingencies not met in the above?
if (where == "combo box") then
TypeKey("esc")
ComboBox(GetFocus(), "esc")
endif
typekey("esc")
say("escape",ot_message)
EndScript

Script PriorRadioButton ()

setfocus(GetPriorWindow(GetFocus()))

EndScript


Script NextRadioButton ()

setfocus(GetNextWindow(GetFocus()))


EndScript


Script SwitchWindows ()

var
string where,
int ke

;ctrl w
let where = giveLocation()

if (where == "guitar window" ) then
if (FindGraphic (0, "close symbol", s_top, s_unrestricted)) then
leftMouseButton()
PCCursor()
{Control+w}
else
saystring("cannot close guitar window")
endif
say(GiveLocation(),OT_USER_REQUESTED_INFORMATION)
endif

if (where == "chord builder window") then
if (FindGraphic (0, "close symbol", s_bottom, s_unrestricted)) then
leftMouseButton()
else
saystring("cannot close chord builder window")
endif
endif

typeKey("ctrl+w")
delay(3)
say(GiveLocation(), OT_MESSAGE)
EndScript


Script SelectNextCharacter ()

if (menusActive() || dialogactive() || !IsPcCursor() || IsVirtualPCCursor () || CaretVisible()) then
PerformScript SelectNextCharacter()
saystring("outa here")
return
endif
typeKey("shift+right arrow")
EndScript

Script SelectPriorCharacter ()

if (menusActive() || dialogactive() || !IsPcCursor() || IsVirtualPCCursor () || CaretVisible()) then
PerformScript SelectPriorCharacter()
return
endif
typeKey("shift+left arrow")

EndScript

Script KillSpeech ()
; toggles spekaing of chords during playback on and off

if MuteSpeechDuringPlaybackFlag == 1 then
  let MuteSpeechDuringPlaybackFlag = 0
  SayMessage(OT_MESSAGE,msgSpeechUnmuted,msgSpeechUnmuted)
else
  let MuteSpeechDuringPlaybackFlag = 1
  SayMessage(OT_MESSAGE,msgSpeechMuted,msgSpeechMuted)
EndIf
IniWriteInteger ("ItemsToSpeak", "ChordsDuringPlayback", MuteSpeechDuringPlaybackFlag, BBWSettingsDir )

EndScript



Void Function SayChord (string Text)
var
  int i,
  int NChords,
  string ch,
  string str,
  string TextOut,
  int nCarats,
  string PushText,
string ChordBreakText,
  string EndText


let str = Text

; if there is a space, then we have multiple chords
let NChords = StringSegmentCount (str, " ")
let i = 1
while ( i <= NChords )
; process each chord separately

; initialize output strings
let EndText = ""
let ChordBreakText = ""
let PushText = ""

let str =  StringSegment (text, " ", i)
; if the chord begins with a special character, strip it
let ch = StringLeft(str,1)
let nCarats = 0
while ( ch == "^" )
  let nCarats = nCarats + 1
  let str = StringChopLeft(str,1)
  let ch = StringLeft(str,1)
EndWhile
if nCarats == 1 then
  let PushText = msgPush8
ElIf nCarats == 2 then
  let PushText = msgPush16
EndIf

; if the chord contains a +, it is augmented
if StringContains (str, "+") then
  let str = StringReplaceSubstrings (str, "+", "")
  let EndText = msgAugmented
EndIF

; look for chord breaks
if StringContains (str, ".") then
let ChordBreakText = str
  let str = StringSegment (str, ".", 1)
  let ChordBreakText = ProcessChordBreaks( StringChopLeft( ChordBreakText, StringLength(str) ) )
EndIf

; determine if this is a suspended chord
if StringContains (str, "sus") then
  let EndText = msgSus
  let str = StringReplaceSubstrings (str, "sus", "" )
EndIf

; added for 2010 version
; determine if this is an augmented chord
if StringContains (str, "aug") then
  let EndText = msgAugmented
  let str = StringReplaceSubstrings (str, "aug", "" )
EndIf

; get the first character - i.e., the chord letter
let ch = StringLeft ( str, 1)
let str = stringChopLeft (str, 1)
let TextOut = ch + separator

; the second character tells whether this is a sharpor natural
if StringLength (str) < 1 Then
  let TextOut = TextOut +space + EndText + space + ChordBreakText + space + PushText
  SayMessage( OT_USER_REQUESTED_INFORMATION, TextOut )
  return
EndIf
let ch = StringLeft (str, 1)
if ch == "b" then
  let TextOut = TextOut + space + msgFlat
  let str = stringChopLeft (str, 1)
ElIf ch == "#" then
  let TextOut = textOut + space + msgSharp
  let str = stringChopLeft (str, 1)
EndIf
; check for major or diminished
if StringLength(str) >=3 then
  let ch = stringLeft (str, 3 )
  if ch == "Maj" then
  let TextOut = TextOut + space + msgMajor
    let str = StringChopLeft( str, 3 )
  ElIf  ch == "dim" then
  let TextOut = TextOut + space + msgDiminished
    let str = StringChopLeft( str, 3 )
  EndIf
EndIf
; check for minor
if StringLength(str) >= 1 then
  let ch = StringLeft( str, 1 )
  if ch == "m" then
    let TextOut = TextOut + space + msgMinor
    let str = StringChopLeft( str, 1 )
  EndIf
EndIf

; parse the rest
while ( StringLength(str) >= 1  )
  let ch = StringLeft( str, 1 )
  if ch == "#" then
    let TextOut = TextOut + space + msgSharp
    let str = StringChopLeft( str, 1 )
  ElIf ch == "b" then
    let TextOut = TextOut + space + msgFlat
    let str = StringChopLeft( str, 1 )
  ElIf ch == "/" then
    ; for alternate bass note
    let EndText = EndText + space + msgOver
    let str = StringChopLeft( str, 1 )
    let ch = StringLeft( str, 1 )
    let EndText = EndText + space + ch
    let str = StringChopLeft( str, 1 )
    ; determine whether this is a sharp or flat
    if StringLength(str) >= 1 then
      let ch = StringLeft( str, 1 )
      if ch == "#" then
        let EndText = EndText + space + msgSharp
        let str = StringChopLeft( str, 1 )
      ElIf ch == "b" then
        let EndText = EndText + space + space + msgFlat
        let str = StringChopLeft( str, 1 )
      EndIf
    EndIf
    let EndText = EndText + space + msgBassNote
  Else
  let TextOut = TextOut + ch
  let str = StringChopLeft( str, 1 )
  if StringToInt (ch) > 1 then
    let TextOut = TextOut + space
  EndIf
  EndIf
EndWhile

let TextOut = TextOut + space + EndText + space + ChordBreakText + space + PushText
SayMessage( OT_USER_REQUESTED_INFORMATION, TextOut )
let i = i+1
EndWhile

EndFunction

String Function ProcessChordBreaks (string Text)
var
  int nPeriods,
  string TextOut,
  string str,
  string ch

; determine the number of "periods"
let nPeriods = StringSegmentCount (Text, ".")
if StringRight (Text, 1) != "." then
  let nPeriods = nPeriods - 1
EndIf

if nPeriods == 1 then
  ; rest
  let TextOut = msgRest
ElIf nPeriods == 2 then
  ; shot
  let TextOut = msgShot
Else
  ; held
  let TextOut = msgHeld
EndIf

; process the rest of the string to find out which instruments are not affected
let str = StringChopLeft( Text, nPeriods )
if StringLength (str) == 0 then
return TextOut
Else
  let TextOut = Textout + space + msgExceptFor
EndIf
while ( StringLength( str ) > 0 )
  let ch = StringLeft( str, 1 )
  if ch == "b" then
    let TextOut = TextOut + space + msgBass
  ElIf ch == "d" then
    let TextOut = TextOut + space + msgDrums
  ElIf ch == "p" then
    let TextOut = TextOut + space + msgPiano
  ElIf ch == "g" then
    let TextOut = TextOut + space + msgGuitar
  ElIf ch == "s" then
let textout =     TextOut + space + msgStrings
  EndIf
  let str = StringChopLeft( str, 1 )
EndWhile
return TextOut

EndFunction

Script ReadStyleMemo ()
var
  handle WHandle,
  string Samples,
  string Description,
  string Other,
  string TextOut

; when browsing styles, speaks what is in the memos fields saying sample songs and a description

; find the first memo window 
let WHandle = FindWindow (GetAppMainWindow(GetFocus()), wcMemo, "" )
if GetWindowClass( GetParent (WHandle) ) == wcStylePicker then
  let Other = "\n" + GetWindowText (WHandle, FALSE)
Else
  ; if not in the style picker dialog, then return
  SayMessage( OT_MESSAGE, msgErr3 )
  return
EndIf

; get info from additional memo fields
let description = msgDescription + "\n\n"
While WHandle != 0
	let WHandle = GetNextWindow (WHandle)
	if GetWindowClass (wHandle) == wcMemo then
	let Description = Description + "" + GetWindowText (WHandle, FALSE)
;  let samples = samples + "\nx" + GetWindowTextEx (WHandle, false, true, true)
	EndIf
EndWhile

let TextOut = Description + "\n" + Other
if IsSameScript () then
  ; write this info to the user buffer and speak it
  SayMessage (OT_USER_REQUESTED_INFORMATION, TextOut )
  UserBufferClear ()
  UserBufferAddText (TextOut + "\n\n" + msg101, "UserBufferDeactivate()" )
  UserBufferActivate (TRUE)
Else
  SayMessage (OT_USER_REQUESTED_INFORMATION, TextOut, TextOut)
EndIf

EndScript

HANDLE Function FindComboBox (int num, string track)
var
handle wh,
string windowname,
int i

;Saystring("ComboBox " + IntToString(num) + " " + Track + " track")
let i = 0
let windowname = track + " Track"
;if (StringContains(GetWindowName(GetRealWindow(GetCurrentwindow())), "DirectX")) then
;in synth settings dialog, 1st combo is to select synth
let wh = FindWindow(GetTopLevelWindow(GetCurrentWindow()), "", windowname)
if (wh) then ;wh
JAWSCursor ()
MoveToWindow (wh)
;let wh = GetLastWindow(wh)
let wh = GetFirstChild(wh)
let wh = GetLastWindow(wh)
;saystring("b4 while loop, the window class is "+GetWindowClass(wh))

while (wh && i < num)
let wh = GetPriorWindow(wh)
;saystring(GetWindowClass(wh))
pause()
if (GetWindowSubtypeCode(wh) == wt_combobox) then ;combobox 
let i = i+1
endif ;combobox 
endWhile
PcCursor()
endif
if (wh) then
;ComboBox(wh, "")
SetFocus (wh)
return wh
else
saystring("combo box not found")
return 0
endif
;else ;not in synth dialog, whole thing is invalid
;return 0
;endif;synth dialog
return wh
EndFunction

Void Function FirstCombo ()

var
handle wh

let wh = FindComboBox(1, "Synth")
if (!wh) then ;we're not in synth dialog, split
say(msgErr4, ot_message)
endif
EndFunction

Void Function secondcombo ()

var
handle wh

let wh = FindComboBox(2, "Synth")
if (!wh) then ;we're not in synth dialog, split
say(msgErr4, ot_message)
endif

EndFunction


Void Function ThirdCombo ()

var
handle wh

let wh = FindComboBox(3, "Synth")
if (!wh) then ;we're not in synth dialog, split
say(msgErr4, ot_message)
endif

EndFunction

Void Function FourthCombo ()

var
handle wh

let wh = FindComboBox(4, "Synth")
if (!wh) then ;we're not in synth dialog, split
say(msgErr4, ot_message)
endif

EndFunction



Void Function fifthCombo ()

var 
handle wh

let wh = FindComboBox(1, "Audio")
if (!wh) then ;we're not in synth dialog, split
say(msgErr4, ot_message)
endif


EndFunction


Void Function sixthCombo ()

var 
handle wh

let wh = FindComboBox(2, "Audio")
if (!wh) then ;we're not in synth dialog, split
say(msgErr4, ot_message)
endif

EndFunction


Void Function LastCombo ()

var 
handle wh

let wh = FindComboBox(3, "Audio")
if (!wh) then ;we're not in synth dialog, split
say(msgErr4, ot_message)
endif

EndFunction


Void Function FindButtons (string track)
var
handle wh,
handle HTrack,
string windowname,
string list,
string SelectedItem,
int item

let windowname = track + " Track"
if (StringContains(GetWindowName(GetRealWindow(GetCurrentwindow())), "DirectX")) then
;in synth settings dialog, 1st combo is to select synth
let wh = FindWindow(GetTopLevelWindow(GetCurrentWindow()), "", windowname)
if (wh) then ;wh
let HTrack = wh
MoveToWindow(wh)
LeftMouseButton()	
;let wh = GetLastWindow(wh)
let wh = GetFirstChild(wh)
let wh = GetLastWindow(wh)
;saystring("b4 while loop, the window class is "+GetWindowClass(wh))

while (wh && !IsKeyWaiting ())
let wh = GetPriorWindow(wh)
;saystring(GetWindowClass(wh))
pause()
if (GetWindowSubtypeCode(wh) == wt_button) then ;button
let list = list + GetWindowName(wh)+separator
endif ;button
endWhile
PcCursor()
let item = DlgSelectItemInList (list, "Synth Settings Dialog", 0, 1)
let selectedItem = StringSegment(list, separator, item)
let wh = FindWindow(HTrack, wcButton, selectedItem)
if (wh) then ;handle of the button was found?
MoveToWindow(wh)
LeftMouseButton()
endif ;handle of the button was found?

endif ;window was found, we're in synth settings
else ;not in synth dialog, whole thing is invalid
say(msgErr4, ot_message)
endif;synth dialog
PcCursor()
return
EndFunction


Script GoToSynthButtons ()
FindButtons("Synth")
EndScript

Void Function GetItems (handle wh, string ByRef list, string ByRef HandleList, string Itemtype, int StartCount, int step, int direction)
var
  int count

let count = StartCount
while ( wh )
  if GetWindowType (wh) == ItemType then
    if step == 0 then
      let list = list + GetWindowName (wh) + separator
    Else
      let list = list + IntToString (count) + " " + GetWindowName (wh) + separator
      let count = count + step
    EndIf
    let HandleList = HandleList + IntToString (wh) + separator  
  EndIf
  if direction == -1 then
    let wh = GetPriorWindow (wh)
  else
    let wh = GetNextWindow (wh)
  EndIf
EndWhile

EndFunction

Script EarTrainingTutor ()
var
  string WindowName,
  int n,
  int item,
  string list,
  string SelectedItem

delay(2)
if IsKeyWaiting () then return EndIf
let n = IsSameScript ()

let WindowName = GetWindowName (GetTopLevelWindow (GetFocus()))

If GiveLocation() != "ear training" then
  SayMessage (OT_MESSAGE, msgErr6 )
  return
EndIf

If n == 2 then
  ; switch to the chord tutor or interval tutor
  let list =  "Chord Tutor" + separator + "Interval Tutor"
  let item = DlgSelectItemInList (list, "Select the Chord or Interval TutorInterval", false, 1)
  if item != 0 then
    let selectedItem = StringSegment(list, separator, item)
    SaveCursor ()
    JAWSCursor ()
    FindString (GetTopLevelWindow(GetFocus()), SelectedItem, S_TOP, S_UNRESTRICTED)
    LeftMouseButton ()
    RestoreCursor ()
    return
  EndIf
EndIf

; display the appropriate choices for the dialog which is active
if StringContains (WindowName, "Chord Tutor")
  || StringContains(WindowName,"Guess Root")
  || WindowName == "Guess Chord" then
  ChordTutor( n )
ElIf StringContains (WindowName, "Interval Tutor")
  || WindowName == "Guess Interval" then 
  IntervalTutor( n )
EndIf


EndScript


Void Function IntervalTutor (int n)
var
  handle wh,
  string list,
  string HandleList,
  string SelectedItem,
  string text,
  int item,
  int i
Refresh (1)
Delay(2)
if n == 0 then
; create the list of available buttons and options

let list = "Speak Results" + separator
let HandleList = "-99" + separator
let wh = FindWindow (GettopLevelWindow(GetFocus()), "Button", "Guess")
GetItems( wh, list, HandleList, "Button", 0, 0, -1 )
let wh = FindWindow (GettopLevelWindow(GetFocus()), "Button", "Hardest")
GetItems( wh, list, HandleList, "Button", 0, 0, 1 )
let wh = FindWindow (GettopLevelWindow(GetFocus()), "", "First Note")
let wh = GetLastWindow(GetFirstChild (wh))
GetItems( wh, list, HandleList, "Combo box", 0, 0, -1 )
let wh = FindWindow (GettopLevelWindow(GetFocus()), "Button", "Defaults")
GetItems( wh, list, HandleList, "Button", 0, 0, -1 )

; make a selection from the list
let item = DlgSelectItemInList (list, "Select an Item", false, 1)
if item != 0 then
  let selectedItem = StringSegment(HandleList, separator, item)
  let wh = StringToHandle (SelectedItem)
  if wh == -99 then
    ; speak the number of correct responses
    SpeakEarTrainingResults()
    return
  EndIf
  MoveToWindow (wh)
  Delay(2)
  LeftMouseButton ()
  Delay(2)
  if GetWindowClass (GetFocus()) == "ComboLBox" then
    ; special processing to open up combo box
    LeftMouseButton ()
  EndIf  ; end of special processing for combo box
EndIf  ; end of if item != 0
PCCursor ()

;EndIf ; end of if n = 0
elif n == 1 then
; create the list of intervals

let list = "Up Intervals" + separator
let HandleList = "-10" + separator
let wh = FindWindow (GetTopLevelWindow (GetFocus()), "", "Up Intervals")
let wh = GetLastWindow(GetFirstChild (wh))
GetItems( wh, list, HandleList, "Radio button", 0, 1, -1 )
let list = list + "Down Intervals" + separator
let HandleList = HandleList + "-10" + separator
let wh = FindWindow (GetTopLevelWindow (GetFocus()), "", "Down Intervals")
let wh = GetLastWindow(GetFirstChild (wh))
GetItems( wh, list, HandleList, "Radio button", 0, 1, -1 )

; select an interval from the list
let item = DlgSelectItemInList (list, "Select an Interval", false, 1)
if item != 0 then
  let selectedItem = StringSegment(list, separator, item)
  ; strip the number from the beginning
  ;let i = StringLength ( StringSegment (SelectedItem, " ", 1) )
  ;let SelectedItem = stringChopLeft (SelectedItem, i+1)
  ;SayString( SelectedItem )
  let selectedItem = StringSegment(HandleList, separator, item)
  let wh = StringToHandle (SelectedItem)
  if wh == -10 then
    ; if the user selects the up or down intervals list item
    SayMessage(OT_MESSAGE,msg102)
    return
  EndIf
  MoveToWindow (wh)
  LeftMouseButton ()
EndIf  ; end of if item != 0
PCCursor ()
Pause()
SpeakEarTrainingResults()

EndIf  ; end of if n = 1


EndFunction
Void Function ChordTutor (int n)
var
  handle wh,
  string list,
  string HandleList,
  string SelectedItem,
  string text,
  string WindowName,
  int item,
  int i

let WindowName = GetWindowName (GetTopLevelWindow (GetFocus()))

Refresh (1)
Delay(2)
if n == 0 then
; create the list of available buttons and options

let list = "Speak Results" + separator
let HandleList = "-99" + separator
let wh = FindWindow (GettopLevelWindow(GetFocus()), "Button", "Guess a New Root")
GetItems( wh, list, HandleList, "Button", 0, 0, -1 )
let wh = FindWindow (GettopLevelWindow(GetFocus()), "Button", "Play Tonic")
GetItems( wh, list, HandleList, "Button", 0, 0, -1 )
let wh = FindWindow (GettopLevelWindow(GetFocus()), "Button", "Hardest")
GetItems( wh, list, HandleList, "Button", 0, 0, 1 )
let wh = FindWindow (GettopLevelWindow(GetFocus()), "", "Extensions to Include")
let wh = FindWindow (GetTopLevelWIndow(GetFocus()), "TCombobox", "")
GetItems( wh, list, HandleList, "Combo box", 0, 0, 1 )
let wh = FindWindow (GettopLevelWindow(GetFocus()), "Button", "Defaults")
GetItems( wh, list, HandleList, "Button", 0, 0, -1 )

; make a selection from the list
let item = DlgSelectItemInList (list, "Select an Item", false, 1)
if item != 0 then
  let selectedItem = StringSegment(HandleList, separator, item)
  let wh = StringToHandle (SelectedItem)
  if wh == -99 then
    ; speak the number of correct responses
    SpeakEarTrainingResults()
    return
  EndIf
  MoveToWindow (wh)
  Delay(2)
  LeftMouseButton ()
  Delay(2)
  if GetWindowClass (GetFocus()) == "ComboLBox" then
    ; special processing to open up combo box
    LeftMouseButton ()
  EndIf  ; end of special processing for combo box
EndIf  ; end of if item != 0
PCCursor ()

;EndIf ; end of if n = 0
elif n == 1 then
; create the list of choices
if StringContains(WindowName,"Chord Tutor")
  || WindowName == "Guess Root" then
; create the list of roots
let list = ""
let HandleList = ""
let wh = FindWindow (GetTopLevelWindow (GetFocus()), "", "Root")
let wh = GetLastWindow(GetFirstChild (wh))
GetItems( wh, list, HandleList, "Radio button", 0, 0, -1 )

; select the root from the list
let item = DlgSelectItemInList (list, "Select the root", false, 1)
if item != 0 then
  let selectedItem = StringSegment(HandleList, separator, item)
  let wh = StringToHandle (SelectedItem)
  MoveToWindow (wh)
  LeftMouseButton ()
EndIf  ; end if item !=0
EndIf  ; end of guess root

if StringContains(WindowName,"Chord Tutor")
  || WindowName == "Guess Chord"
  || WindowName == "Guess Root and Chord"  then
; create the list of extensions
let list = ""
let HandleList = ""
let wh = FindWindow (GetTopLevelWindow (GetFocus()), "", "Extension")
let wh = GetLastWindow(GetFirstChild (wh))
GetItems( wh, list, HandleList, "Radio button", 0, 0, -1 )

; select the extension from the list
let item = DlgSelectItemInList (list, "Select the extension", false, 1)
if item != 0 then
  let selectedItem = StringSegment(HandleList, separator, item)
  let wh = StringToHandle (SelectedItem)
  MoveToWindow (wh) 
  LeftMouseButton ()
EndIf  ; end of if item != 0
EndIf  ; end of guess chord
PCCursor ()

Pause()
Delay(2)
SpeakEarTrainingResults()
EndIf  ; end of if n = 1


EndFunction

void Function SpeakEarTrainingResults ()
var
  string text
; speak the number of correct responses
SaveCursor()
;JAWSCursor ()
FindString (GetTopLevelWindow(GetFocus()), "You have answered", S_TOP, S_UNRESTRICTED)
let text = GetLine ()
let text = StringSegment (text, ".", 1)
RestoreCursor()
SayMessage (OT_MESSAGE, text, text)

EndFunction


Void Function OutputBarBeatChord (string text, int BrailleOnly )
var
  int bar,
  int beat,
  string sBar,
  string sBeat,
  handle hwnd

let hwnd = GetTopLevelWindow (GetCurrentWindow())
let sBar = GetBar(hwnd)
let sBeat = GetBeat(hwnd)
let bar = StringToInt(sBar)
let beat = StringToInt(sBeat)
  if BrailleInUse () then
    if bar== 0 || !BrailleIsMessageBeingShown () 
      || (bar!=prevbar || beat!=prevbeat) then
      ; if there is no braile message or the bar or beat has changed, create a new message
      BrailleMessage (IntToString(bar) + ":" + IntToString(beat), 0, 0)
    EndIf
    ; append the highlighted chord to the existing braille message
    BrailleMessage (" " + text, 1, 0)
  EndIf
  if !BrailleOnly then
    if (beat!=0) && ((bar!=prevbar || beat!=prevbeat)) then
      SayInteger(bar)
      SayInteger(beat)
    EndIf
    SayChord( Text )
  EndIf
  let prevbar = bar
  let prevbeat = beat

EndFunction

Script SpeakSpecialKeys ()
var
  string ScriptKey

let ScriptKey = GetCurrentScriptKeyName ()

if SpeakSpecialKeysFlag >= 1 then

if StringCompare (ScriptKey, "Control+Shift+Q", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftQ)
ElIf StringCompare (ScriptKey, "Control+Shift+W", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftW)
ElIf StringCompare (ScriptKey, "Control+Shift+E", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftE)
ElIf StringCompare (ScriptKey, "Control+Shift+R", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftR)
ElIf StringCompare (ScriptKey, "Control+Shift+T", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftT)
ElIf StringCompare (ScriptKey, "Control+Shift+Y", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftY)
ElIf StringCompare (ScriptKey, "Control+Shift+U", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftU)
ElIf StringCompare (ScriptKey, "Control+Shift+I", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftI)
ElIf StringCompare (ScriptKey, "Control+Shift+O", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftO)
ElIf StringCompare (ScriptKey, "Control+Shift+P", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftP)
ElIf StringCompare (ScriptKey, "Control+Shift+-", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftDash)
ElIf StringCompare (ScriptKey, "Control+Shift+Equals", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgControlShiftEquals)
ElIf StringCompare (ScriptKey, "Alt+Control+Shift+R", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgAltControlShiftR)
ElIf StringCompare (ScriptKey, "Alt+Control+A", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgAltControlA)
ElIf StringCompare (ScriptKey, "Alt+Control+S", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgAltControlS)
ElIf StringCompare (ScriptKey, "Alt+Control+D", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgAltControlD)
ElIf StringCompare (ScriptKey, "Alt+Control+Shift+Q", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgAltControlShiftQ)
ElIf StringCompare (ScriptKey, "Alt+Control+Shift+W", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgAltControlShiftW)
ElIf StringCompare (ScriptKey, "Alt+Control+Shift+E", FALSE) == 0 then
  SayMessage (OT_USER_REQUESTED_INFORMATION, msgAltControlShiftE)
EndIf

EndIf  ; end of if SpecialKeysFlag 

if SpeakSpecialKeysFlag < 2 then
  ; perform the function if SpeakSpecialKeysFlag = 0 or 1
  TypeCurrentScriptKey ()
EndIf


EndScript

Script LoopingDialog ()
var
  string list,
  int item,
  handle wh,
  string text,
  int DoNotDisplayChords

let DoNotDisplayChords = 0
let wh = GetFocus()
; check for looping status
SaveCursor ()
InvisibleCursor ()
let wh = FindWindow (wh, "", "LoopSec")
MoveToWindow (wh)
if ControlIsChecked () then
  let text = " (currently on)"
Else
  let text = " (currently off)"
EndIf
RestoreCursor ()

; create list of selections
let list = "toggle looping on/off" + text + separator
  + "open loop section settings dialog" + separator
  + "play with last chorus looped" + separator
  + "play with middle choruses looped" + separator
  + "play with middle and last choruses looped" + separator
  + "Jump to last chorus (no looping)" + separator
  + "Jump to ending (no looping)"

; make selection from dialog
let item = DlgSelectItemInList (list, "Looping Options", FALSE, 1)
if item <= 0 then
  ; re-display and speak the bar/beat and chord info
  PerformScript RepeatChords()
  return
EndIf

; get into the loop menu item
TypeKey("Alt+P")
TypeKey("L")

if item == 1 then
  TypeKey("l")
ElIf item == 2 then
  TypeKey("O")
  let DoNotDisplayChords = 1
ElIf item == 3 then
  Typekey("p")
ElIf item == 4 then
  TypeKey("a")
ElIf item == 5 then
  TypeKey("y")
ElIf item == 6 then
ElIf item == 7 then
  TypeKey("u")
  TypeKey("j")
EndIf

if !DoNotDisplayChords then
  ; re-display and speak the bar/beat and chord info
  PerformScript RepeatChords()
EndIf


EndScript

Void Function KeyboardHelpHook (string ScriptName, string FrameName)
var
  int SaveFlag
; the following was added to speak the special BIAB hotkeys when in keyboard help
if gbKeyboardHelp then
  let SaveFlag = SpeakSpecialKeysFlag
  let SpeakSpecialKeysFlag = 2 ; just speak keys, do not perform function
  PerformScript SpeakSpecialKeys()
  let SpeakSpecialKeysFlag = SaveFlag
EndIf

KeyboardHelpHook (ScriptName, FrameName)

EndFunction

void function MoveOutOfRadioButtons( int direction )
var
  int max,
  handle hwnd,
  int bSpeechState
let bSpeechState = IsSpeechOff ()
if !bSpeechState then SpeechOff () EndIf

let max = 0
let hwnd = GetFocus()

while (max<10) && (GetWindowTypeCode (GetCurrentWindow(), TRUE) == WT_RADIOBUTTON)
  if direction == 1 then
    TabKey ()
  else
    ShiftTabKey ()
  EndIf
  Pause ()
  let max = max + 1
EndWhile
MoveToWindow (hwnd)
LeftMouseButton ()
Pause ()
if !bSpeechState then SpeechOn () EndIf
Pause ()
if direction == 1 then
  TabKey ()
else
  ShiftTabKey ()
EndIf
PCCursor ()

EndFunction

Script AdjustJAWSOptions ()
;This function call sends the optional TRUE parameter as second
;so that we retain node settings that we define,
;including those at level 0.
;If you want us to create nodes for you, call the below function in your own copy of this script,
;and include the following:
;Second parameter (optional) = false, or ignore.
;If second parameter is filled in as FALSE, optionally fill in third parameter,
;with a name for the node under which we will place all your options that do not have node paths.
;Otherwise, call this function with just the parameter with your options like this:
;OptionsTreeCore(strMyOptionsLinst)
;And at the top of the Adjust JAWS Options dialog, you will see a node as follows:
;ConfigurationName Options
;Where ConfigurationName is the name of your configuration,
;e.g. Skype Options
if InHJDialog () then
	SayFormattedMessage (OT_error, cMSG337_L, cMSG337_S)
	return
endIf
OptionsTreeCore (sOptionsList,FALSE,msgBIABSettings)

EndScript

String Function UOSpeakSpecialKeys (int iRetCurVal )
var string sText

if not iRetCurVal then
  if SpeakSpecialKeysFlag == 1 then
    let SpeakSpecialKeysFlag = 0
  else
    let SpeakSpecialKeysFlag = 1
  EndIf
  IniWriteInteger ("ItemsToSpeak", "SpecialKeys", SpeakSpecialKeysFlag, BBWSettingsDir )
EndIf

let SpeakSpecialKeysFlag = IniReadInteger ("ItemsToSpeak", "SpecialKeys", 1, BBWSettingsDir)
if SpeakSpecialKeysFlag == 1 then
  let sText = msgOn
else
  let sText = msgOff
Endif

return sText

EndFunction

String Function UOSpeakSpecialKeysHlp ()
return msgSpeakSpecialKeysText
EndFunction


String Function UOMuteSpeechDuringPlayback(int iRetCurVal )
var string sText

if not iRetCurVal then
  if MuteSpeechDuringPlaybackFlag == 1 then
    let MuteSpeechDuringPlaybackFlag = 0
  else
    let MuteSpeechDuringPlaybackFlag = 1
  EndIf
  IniWriteInteger ("ItemsToSpeak", "ChordsDuringPlayback", MuteSpeechDuringPlaybackFlag, BBWSettingsDir )
EndIf

let MuteSpeechDuringPlaybackFlag = IniReadInteger ("ItemsToSpeak", "ChordsDuringPlayback", 1, BBWSettingsDir)
if MuteSpeechDuringPlaybackFlag == 1 then
  let sText = msgOn
else
  let sText = msgOff
Endif

return sText

EndFunction

String Function UOMuteSpeechDuringPlaybackHlp()
return msgMuteSpeechDuringPlaybackText
EndFunction


String Function UOSpeakToolTips(int iRetCurVal )
var string sText

if not iRetCurVal then
  if SpeakToolTipsFlag == 1 then
    let SpeakToolTipsFlag = 0
  else
    let SpeakToolTipsFlag = 1
  EndIf
  IniWriteInteger ("ItemsToSpeak", "ToolTips", SpeakToolTipsFlag, BBWSettingsDir )
EndIf

let SpeakToolTipsFlag = IniReadInteger ("ItemsToSpeak", "ToolTips", 1, BBWSettingsDir)
if SpeaktoolTipsFlag == 1 then
  let sText = msgOn
else
  let sText = msgOff
Endif

return sText

EndFunction

String Function UOSpeakToolTipsHlp ()
return msgSpeaktoolTipsText
EndFunction


Script F4Key ()

let IgnoreMuteSpeechDuringPlayback = 0
TypeKey("F4")

EndScript

Script SpaceBar ()

let IgnoreMuteSpeechDuringPlayback = 0
TypeKey("space")

EndScript

Script controlH ()

let IgnoreMuteSpeechDuringPlayback = 1
TypeKey("Control+H")

EndScript

Script ControlG ()

let IgnoreMuteSpeechDuringPlayback = 0
TypeKey("Control+G")

EndScript

Script SpeakToolTip ()
var
	string text

let text = GetLine () + "\n\n" + LastNewText
if IsSameScript () then
	SayMessage( OT_USER_BUFFER, text, text)
Else
	SayMessage( OT_MESSAGE, text, text)
EndIf


EndScript
